package com.daim.flutter_apm

import androidx.annotation.NonNull
import com.daim.flutter_apm.APMFlutterUtils
import com.moonmiles.apm.sdk.service.APMUIServicesUser
import com.moonmiles.apmservices.model.APMGifts
import com.moonmiles.apmservices.model.APMUser
import com.moonmiles.apmservices.model.optin.APMOptins
import com.moonmiles.apmservices.net.APMException
import com.moonmiles.apmservices.sdk.gift.APMGiftListListener
import com.moonmiles.apmservices.sdk.gift.APMServicesGift
import com.moonmiles.apmservices.sdk.user.APMUserConnectListener
import com.moonmiles.apmservices.sdk.user.APMUserDeleteListener
import com.moonmiles.apmservices.sdk.user.APMUserLogoutListener
import com.moonmiles.apmservices.sdk.user.APMUserOptinsListener
import com.moonmiles.apmservices.utils.APMStatUtils
import com.moonmiles.apmservices.utils.model.user_properties.APMUserPropertiesUtils
import io.flutter.embedding.engine.plugins.FlutterPlugin
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import java.util.*
import kotlin.collections.HashMap

/** APMStatUtilsModule */
class APMStatUtilsModule : FlutterPlugin, MethodCallHandler {
    private lateinit var channel: MethodChannel

    override fun onAttachedToEngine(@NonNull flutterPluginBinding: FlutterPlugin.FlutterPluginBinding) {
        channel = MethodChannel(flutterPluginBinding.binaryMessenger, "apm_stat_utils_module")
        channel.setMethodCallHandler(this)
    }

    override fun onDetachedFromEngine(@NonNull binding: FlutterPlugin.FlutterPluginBinding) {
        channel.setMethodCallHandler(null)
    }

    override fun onMethodCall(@NonNull call: MethodCall, @NonNull result: Result) {
        val arguments: ArrayList<*>
        if(call.arguments != null) {
            arguments = call.arguments as ArrayList<*>
        }
        else {
            arguments = ArrayList<Any>()
        }

        if (call.method == "setEnabledOptinStat") {
            setEnabledOptinStat(arguments, result)
        }
        else {
            result.notImplemented()
        }
    }

    private fun setEnabledOptinStat(arguments: ArrayList<*>, result: Result) {
        APMStatUtils.sharedInstance().setEnabledOptinStat(arguments[0] as Boolean, object : APMUserOptinsListener {
            override fun userOptinsSuccess(optins: APMOptins?) {
                APMFlutterUtils.resolveResult(optins, result)
            }

            override fun failure(exception: APMException?) {
                APMFlutterUtils.rejectResult(exception, result)
            }
        })
    }
}
