// Copyright 2018 The Flutter team. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

import 'package:flutter/material.dart';
import 'package:flutter_apm_example/utils/apm_utils.dart';
import 'package:flutter_apm/apm_module.dart';

class SecondScreen extends StatefulWidget {
  @override
  _SecondScreenState createState() => _SecondScreenState();
}

class _SecondScreenState extends State<SecondScreen> {
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text("Second screen"),
      ),
      body: Center(
        child: Column(
          mainAxisAlignment: MainAxisAlignment.center,
          children: <Widget>[
            ElevatedButton(
              onPressed: () => APMUtils.apmConnection(false),
              child: Text("Connect user OK"),
            ),
            ElevatedButton(
              onPressed: () => APMUtils.apmConnection(true),
              child: Text("Connect user KO"),
            ),
            ElevatedButton(
              onPressed: () => APMUtils.userLogout(),
              child: Text("Logout user"),
            ),
            ElevatedButton(
              onPressed: () => APMUtils.triggerAction('tag1'),
              child: Text("triggerAction('tag1')"),
            ),
            ElevatedButton(
              onPressed: () => APMUtils.triggerAction('tag2'),
              child: Text("triggerAction('tag2')"),
            ),
            ElevatedButton(
              onPressed: () => APMUtils.testAPMUIServicesUserModule(),
              child: Text("APMUtils.testAPMUIServicesUserModule()"),
            ),
            ElevatedButton(
              onPressed: () => APMUtils.testAll(),
              child: Text("Test All"),
            ),
            ElevatedButton(
              onPressed: () => APMModule.openBigBadge(),
              child: Text("APMModule.openBigBadge"),
            ),
          ],
        )
      ), // This trailing comma makes auto-formatting nicer for build methods.
    );
  }
}
