import Flutter
import UIKit
import APM

public class APMConfigModule: NSObject, FlutterPlugin {
    public static func register(with registrar: FlutterPluginRegistrar) {
        let instance = APMConfigModule()
        let channel = FlutterMethodChannel(name: "apm_config_module", binaryMessenger: registrar.messenger())
        registrar.addMethodCallDelegate(instance, channel: channel)
    }

    public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
        let arguments: [Any] = (call.arguments ?? []) as! [Any]
        
        if (call.method == "APM_BADGE_NATURE_BANNER") {
            FUNC_APM_BADGE_NATURE_BANNER(arguments: arguments, result: result)
        }
        else if (call.method == "APM_BADGE_NATURE_STICKER") {
            FUNC_APM_BADGE_NATURE_STICKER(arguments: arguments, result: result)
        }
        else if (call.method == "APM_SHOW_CONTROLLER_DAILY_CHALLENGE") {
            FUNC_APM_SHOW_CONTROLLER_DAILY_CHALLENGE(arguments: arguments, result: result)
        }
        else if (call.method == "APM_SHOW_CONTROLLER_MY_ACCOUNT") {
            FUNC_APM_SHOW_CONTROLLER_MY_ACCOUNT(arguments: arguments, result: result)
        }
        else if (call.method == "APM_SHOW_CONTROLLER_EARNS") {
            FUNC_APM_SHOW_CONTROLLER_EARNS(arguments: arguments, result: result)
        }
        else if (call.method == "APM_SHOW_CONTROLLER_BURNS") {
            FUNC_APM_SHOW_CONTROLLER_BURNS(arguments: arguments, result: result)
        }
        else if (call.method == "APM_SHOW_CONTROLLER_GIFTS") {
            FUNC_APM_SHOW_CONTROLLER_GIFTS(arguments: arguments, result: result)
        }
        else if (call.method == "APM_SHOW_CONTROLLER_STATUS") {
            FUNC_APM_SHOW_CONTROLLER_STATUS(arguments: arguments, result: result)
        }
        else if (call.method == "APM_SHOW_CONTROLLER_PAGE") {
            FUNC_APM_SHOW_CONTROLLER_PAGE(arguments: arguments, result: result)
        }
        else if (call.method == "APM_SHOW_CONTROLLER_CHALLENGES") {
            FUNC_APM_SHOW_CONTROLLER_CHALLENGES(arguments: arguments, result: result)
        }
        else if (call.method == "APM_SHOW_CONTROLLER_TROPHIES") {
            FUNC_APM_SHOW_CONTROLLER_TROPHIES(arguments: arguments, result: result)
        }
        else if (call.method == "APM_SHOW_CONTROLLER_INFOS") {
            FUNC_APM_SHOW_CONTROLLER_INFOS(arguments: arguments, result: result)
        }
        else if (call.method == "APM_SHOW_CONTROLLER_GIFT") {
            FUNC_APM_SHOW_CONTROLLER_GIFT(arguments: arguments, result: result)
        }
        else if (call.method == "APM_SHOW_CONTROLLER_BARCODE") {
            FUNC_APM_SHOW_CONTROLLER_BARCODE(arguments: arguments, result: result)
        }
        else if (call.method == "APM_SHOW_CONTROLLER_UNSUBSCRIBE") {
            FUNC_APM_SHOW_CONTROLLER_UNSUBSCRIBE(arguments: arguments, result: result)
        }
        else {
            result(FlutterMethodNotImplemented)
        }
    }

    private func FUNC_APM_BADGE_NATURE_BANNER(arguments: [Any], result: @escaping FlutterResult) {
        result(APM_BADGE_NATURE_BANNER)
    }
    
    private func FUNC_APM_BADGE_NATURE_STICKER(arguments: [Any], result: @escaping FlutterResult) {
        result(APM_BADGE_NATURE_STICKER)
    }
    
    private func FUNC_APM_SHOW_CONTROLLER_DAILY_CHALLENGE(arguments: [Any], result: @escaping FlutterResult) {
        result(APM_SHOW_CONTROLLER_DAILY_CHALLENGE)
    }
    
    private func FUNC_APM_SHOW_CONTROLLER_MY_ACCOUNT(arguments: [Any], result: @escaping FlutterResult) {
        result(APM_SHOW_CONTROLLER_MY_ACCOUNT)
    }
    
    private func FUNC_APM_SHOW_CONTROLLER_EARNS(arguments: [Any], result: @escaping FlutterResult) {
        result(APM_SHOW_CONTROLLER_EARNS)
    }
    
    private func FUNC_APM_SHOW_CONTROLLER_BURNS(arguments: [Any], result: @escaping FlutterResult) {
        result(APM_SHOW_CONTROLLER_BURNS)
    }
    
    private func FUNC_APM_SHOW_CONTROLLER_GIFTS(arguments: [Any], result: @escaping FlutterResult) {
        result(APM_SHOW_CONTROLLER_GIFTS)
    }
    
    private func FUNC_APM_SHOW_CONTROLLER_STATUS(arguments: [Any], result: @escaping FlutterResult) {
        result(APM_SHOW_CONTROLLER_STATUS)
    }
    
    private func FUNC_APM_SHOW_CONTROLLER_PAGE(arguments: [Any], result: @escaping FlutterResult) {
        result(APM_SHOW_CONTROLLER_PAGE)
    }
    
    private func FUNC_APM_SHOW_CONTROLLER_CHALLENGES(arguments: [Any], result: @escaping FlutterResult) {
        result(APM_SHOW_CONTROLLER_CHALLENGES)
    }
    
    private func FUNC_APM_SHOW_CONTROLLER_TROPHIES(arguments: [Any], result: @escaping FlutterResult) {
        result(APM_SHOW_CONTROLLER_TROPHIES)
    }
    
    private func FUNC_APM_SHOW_CONTROLLER_INFOS(arguments: [Any], result: @escaping FlutterResult) {
        result(APM_SHOW_CONTROLLER_INFOS)
    }
    
    private func FUNC_APM_SHOW_CONTROLLER_GIFT(arguments: [Any], result: @escaping FlutterResult) {
        result(APM_SHOW_CONTROLLER_GIFT)
    }
    
    private func FUNC_APM_SHOW_CONTROLLER_BARCODE(arguments: [Any], result: @escaping FlutterResult) {
        result(APM_SHOW_CONTROLLER_BARCODE)
    }
    
    private func FUNC_APM_SHOW_CONTROLLER_UNSUBSCRIBE(arguments: [Any], result: @escaping FlutterResult) {
        result(APM_SHOW_CONTROLLER_UNSUBSCRIBE)
    }
}
