import Flutter
import UIKit
import APM

public class APMStatUtilsModule: NSObject, FlutterPlugin {
    public static func register(with registrar: FlutterPluginRegistrar) {
        let instance = APMStatUtilsModule()
        let channel = FlutterMethodChannel(name: "apm_stat_utils_module", binaryMessenger: registrar.messenger())
        registrar.addMethodCallDelegate(instance, channel: channel)
    }

    public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
        let arguments: [Any] = (call.arguments ?? []) as! [Any]
        
        if (call.method == "setEnabledOptinStat") {
            setEnabledOptinStat(arguments: arguments, result: result)
        }
        else {
            result(FlutterMethodNotImplemented)
        }
    }

    private func setEnabledOptinStat(arguments: [Any], result: @escaping FlutterResult) {
        APMStatUtils.sharedInstance()?.setEnabledOptinStat(arguments[0] as! Bool, userOptinsSuccess: { (optins: APMOptins?) in
            APMFlutterUtils.resolveResult(object: optins, result: result)
        }, failure: { (error: Error?) in
            APMFlutterUtils.rejectResultWithError(error: error! as NSError, result: result)
        })
    }
}
