// Copyright 2018 The Flutter team. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

import 'dart:developer';
import 'package:flutter/material.dart';
import 'apm_module.dart';

class APMNavigatorObserver<R extends Route<dynamic>> extends RouteObserver<R> {
  APMNavigatorObserver();

  @override
  void didPush(Route route, Route? previousRoute) {
    log('{didPush} \n route: $route \n previousRoute: $previousRoute');
    super.didPush(route, previousRoute);
    APMModule.refreshSDK(false);
  }

  @override
  void didPop(Route route, Route? previousRoute) {
    log('{didPop} \n route: $route \n previousRoute: $previousRoute');
    super.didPop(route, previousRoute);
    APMModule.refreshSDK(false);
  }

  @override
  void didReplace({Route? newRoute, Route? oldRoute}) {
    log('{didReplace} \n newRoute: $newRoute \n oldRoute: $oldRoute');
    super.didReplace(newRoute: newRoute, oldRoute: oldRoute);
    APMModule.refreshSDK(false);
  }
}
